ghc-lib-parser-9.12.2.20250421: The GHC API, decoupled from GHC versions

Safe Haskell | Ignore
Language | GHC2021

GHC.Core.Coercion.Axiom

Contents

- Orphan instances

Description

Module for coercion axioms, used to represent type family instances and newtypes

Synopsis

- data BranchFlag
- type Branched = 'Branched
- type Unbranched = 'Unbranched
- type BranchIndex = Int
- newtype Branches (br :: BranchFlag) = MkBranches {
  - unMkBranches :: Array BranchIndex CoAxBranch
  }
- manyBranches :: [CoAxBranch] -> Branches Branched
- unbranched :: CoAxBranch -> Branches Unbranched
- fromBranches :: forall (br :: BranchFlag). Branches br -> [CoAxBranch]
- numBranches :: forall (br :: BranchFlag). Branches br -> Int
- mapAccumBranches :: forall (br :: BranchFlag). ([CoAxBranch] -> CoAxBranch -> CoAxBranch) -> Branches br -> Branches br
- data CoAxiom (br :: BranchFlag) = CoAxiom {
  - co_ax_unique :: Unique
  - co_ax_name :: Name
  - co_ax_role :: Role
  - co_ax_tc :: TyCon
  - co_ax_branches :: Branches br
  - co_ax_implicit :: Bool
  }
- data CoAxBranch = CoAxBranch {
  - cab_loc :: SrcSpan
  - cab_tvs :: [TyVar]
  - cab_eta_tvs :: [TyVar]
  - cab_cvs :: [CoVar]
  - cab_roles :: [Role]
  - cab_lhs :: [Type]
  - cab_rhs :: Type
  - cab_incomps :: [CoAxBranch]
  }
- toBranchedAxiom :: forall (br :: BranchFlag). CoAxiom br -> CoAxiom Branched
- toUnbranchedAxiom :: forall (br :: BranchFlag). CoAxiom br -> CoAxiom Unbranched
- coAxiomName :: forall (br :: BranchFlag). CoAxiom br -> Name
- coAxiomArity :: forall (br :: BranchFlag). CoAxiom br -> BranchIndex -> Arity
- coAxiomBranches :: forall (br :: BranchFlag). CoAxiom br -> Branches br
- coAxiomTyCon :: forall (br :: BranchFlag). CoAxiom br -> TyCon
- isImplicitCoAxiom :: forall (br :: BranchFlag). CoAxiom br -> Bool
- coAxiomNumPats :: forall (br :: BranchFlag). CoAxiom br -> Int
- coAxiomNthBranch :: forall (br :: BranchFlag). CoAxiom br -> BranchIndex -> CoAxBranch
- coAxiomSingleBranch_maybe :: forall (br :: BranchFlag). CoAxiom br -> Maybe CoAxBranch
- coAxiomRole :: forall (br :: BranchFlag). CoAxiom br -> Role
- coAxiomSingleBranch :: CoAxiom Unbranched -> CoAxBranch
- coAxBranchTyVars :: CoAxBranch -> [TyVar]
- coAxBranchCoVars :: CoAxBranch -> [CoVar]
- coAxBranchRoles :: CoAxBranch -> [Role]
- coAxBranchLHS :: CoAxBranch -> [Type]
- coAxBranchRHS :: CoAxBranch -> Type
- coAxBranchSpan :: CoAxBranch -> SrcSpan
- coAxBranchIncomps :: CoAxBranch -> [CoAxBranch]
- placeHolderIncomps :: [CoAxBranch]
- data Role
  - = Nominal
  - | Representational
  - | Phantom
- fsFromRole :: Role -> FastString
- data CoAxiomRule
  - = BuiltInFamRew BuiltInFamRewrite
  - | BuiltInFamInj BuiltInFamInjectivity
  - | BranchedAxiom (CoAxiom Branched) BranchIndex
  - | UnbranchedAxiom (CoAxiom Unbranched)
- data BuiltInFamRewrite = BIF_Rewrite {
  - bifrw_name :: FastString
  - bifrw_axr :: CoAxiomRule
  - bifrw_fam_tc :: TyCon
  - bifrw_arity :: Arity
  - bifrw_match :: [Type] -> Maybe ([Type], Type)
  - bifrw_proves :: [TypeEqn] -> Maybe TypeEqn
  }
- data BuiltInFamInjectivity = BIF_Interact {
  - bifinj_name :: FastString
  - bifinj_axr :: CoAxiomRule
  - bifinj_proves :: TypeEqn -> Maybe TypeEqn
  }
- type TypeEqn = Pair Type
- coAxiomRuleArgRoles :: CoAxiomRule -> [Role]
- coAxiomRuleRole :: CoAxiomRule -> Role
- coAxiomRuleBranch_maybe :: CoAxiomRule -> Maybe (TyCon, Role, CoAxBranch)
- isNewtypeAxiomRule_maybe :: CoAxiomRule -> Maybe (TyCon, CoAxBranch)
- data BuiltInSynFamily = BuiltInSynFamily {
  - sfMatchFam :: [BuiltInFamRewrite]
  - sfInteract :: [BuiltInFamInjectivity]
  }
- trivialBuiltInFamily :: BuiltInSynFamily

# Documentation

data BranchFlag Source #

type Branched = 'Branched Source #

type Unbranched = 'Unbranched Source #

type BranchIndex = Int Source #

newtype Branches (br :: BranchFlag) Source #

Constructors

MkBranches |

Fields

- unMkBranches :: Array BranchIndex CoAxBranch

manyBranches :: [CoAxBranch] -> Branches Branched Source #

unbranched :: CoAxBranch -> Branches Unbranched Source #

fromBranches :: forall (br :: BranchFlag). Branches br -> [CoAxBranch] Source #

numBranches :: forall (br :: BranchFlag). Branches br -> Int Source #

mapAccumBranches :: forall (br :: BranchFlag). ([CoAxBranch] -> CoAxBranch -> CoAxBranch) -> Branches br -> Branches br Source #

The `[CoAxBranch]` passed into the mapping function is a list of all previous branches, reversed

data CoAxiom (br :: BranchFlag) Source #

A `CoAxiom` is a "coercion constructor", i.e. a named equality axiom.

Constructors

CoAxiom |

Fields

- co_ax_unique :: Unique
- co_ax_name :: Name
- co_ax_role :: Role
- co_ax_tc :: TyCon
- co_ax_branches :: Branches br
- co_ax_implicit :: Bool

#### Instances

Instances details

Typeable br => Data (CoAxiom br) Source # |

Instance details

Defined in GHC.Core.Coercion.Axiom

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> CoAxiom br -> c (CoAxiom br) Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c (CoAxiom br) Source #

toConstr :: CoAxiom br -> Constr Source #

dataTypeOf :: CoAxiom br -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c (CoAxiom br)) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c (CoAxiom br)) Source #

gmapT :: (forall b. Data b => b -> b) -> CoAxiom br -> CoAxiom br Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> CoAxiom br -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> CoAxiom br -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> CoAxiom br -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> CoAxiom br -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> CoAxiom br -> m (CoAxiom br) Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> CoAxiom br -> m (CoAxiom br) Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> CoAxiom br -> m (CoAxiom br) Source #

NamedThing (CoAxiom br) Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods getOccName :: CoAxiom br -> OccName Source # getName :: CoAxiom br -> Name Source #
Uniquable (CoAxiom br) Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods getUnique :: CoAxiom br -> Unique Source #
Outputable (CoAxiom br) Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods ppr :: CoAxiom br -> SDoc Source #
Eq (CoAxiom br) Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods (==) :: CoAxiom br -> CoAxiom br -> Bool Source # (/=) :: CoAxiom br -> CoAxiom br -> Bool Source #

data CoAxBranch Source #

A branch of a coercion axiom, which provides the evidence for unwrapping a newtype or a type-family reduction step using a single equation.

Constructors

CoAxBranch |

Fields

- cab_loc :: SrcSpan

  Location of the defining equation See Note [CoAxiom locations]

- cab_tvs :: [TyVar]

  Bound type variables; not necessarily fresh See Note [CoAxBranch type variables]

- cab_eta_tvs :: [TyVar]

  Eta-reduced tyvars cab_tvs and cab_lhs may be eta-reduced; see Note [Eta reduction for data families]

- cab_cvs :: [CoVar]

  Bound coercion variables Always empty, for now. See Note [Constraints in patterns] in GHC.Tc.TyCl

- cab_roles :: [Role]

  See Note [CoAxBranch roles]

- cab_lhs :: [Type]

  Type patterns to match against

- cab_rhs :: Type

  Right-hand side of the equality See Note [CoAxioms are homogeneous]

- cab_incomps :: [CoAxBranch]

  The previous incompatible branches See Note [Storing compatibility]

#### Instances

Instances details

Data CoAxBranch Source # |

Instance details

Defined in GHC.Core.Coercion.Axiom

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> CoAxBranch -> c CoAxBranch Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c CoAxBranch Source #

toConstr :: CoAxBranch -> Constr Source #

dataTypeOf :: CoAxBranch -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c CoAxBranch) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c CoAxBranch) Source #

gmapT :: (forall b. Data b => b -> b) -> CoAxBranch -> CoAxBranch Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> CoAxBranch -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> CoAxBranch -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> CoAxBranch -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> CoAxBranch -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> CoAxBranch -> m CoAxBranch Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> CoAxBranch -> m CoAxBranch Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> CoAxBranch -> m CoAxBranch Source #

Outputable CoAxBranch Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods ppr :: CoAxBranch -> SDoc Source #

toBranchedAxiom :: forall (br :: BranchFlag). CoAxiom br -> CoAxiom Branched Source #

toUnbranchedAxiom :: forall (br :: BranchFlag). CoAxiom br -> CoAxiom Unbranched Source #

coAxiomName :: forall (br :: BranchFlag). CoAxiom br -> Name Source #

coAxiomArity :: forall (br :: BranchFlag). CoAxiom br -> BranchIndex -> Arity Source #

coAxiomBranches :: forall (br :: BranchFlag). CoAxiom br -> Branches br Source #

coAxiomTyCon :: forall (br :: BranchFlag). CoAxiom br -> TyCon Source #

isImplicitCoAxiom :: forall (br :: BranchFlag). CoAxiom br -> Bool Source #

coAxiomNumPats :: forall (br :: BranchFlag). CoAxiom br -> Int Source #

coAxiomNthBranch :: forall (br :: BranchFlag). CoAxiom br -> BranchIndex -> CoAxBranch Source #

coAxiomSingleBranch_maybe :: forall (br :: BranchFlag). CoAxiom br -> Maybe CoAxBranch Source #

coAxiomRole :: forall (br :: BranchFlag). CoAxiom br -> Role Source #

coAxiomSingleBranch :: CoAxiom Unbranched -> CoAxBranch Source #

coAxBranchTyVars :: CoAxBranch -> [TyVar] Source #

coAxBranchCoVars :: CoAxBranch -> [CoVar] Source #

coAxBranchRoles :: CoAxBranch -> [Role] Source #

coAxBranchLHS :: CoAxBranch -> [Type] Source #

coAxBranchRHS :: CoAxBranch -> Type Source #

coAxBranchSpan :: CoAxBranch -> SrcSpan Source #

coAxBranchIncomps :: CoAxBranch -> [CoAxBranch] Source #

placeHolderIncomps :: [CoAxBranch] Source #

data Role Source #

See Note [Roles] in GHC.Core.Coercion

Order of constructors matters: the Ord instance coincides with the *super*typing relation on roles.

Constructors

Nominal |
Representational |
Phantom |

#### Instances

Instances details

Data Role Source # |

Instance details

Defined in Language.Haskell.Syntax.Basic

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Role -> c Role Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Role Source #

toConstr :: Role -> Constr Source #

dataTypeOf :: Role -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Role) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Role) Source #

gmapT :: (forall b. Data b => b -> b) -> Role -> Role Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Role -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Role -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Role -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Role -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Role -> m Role Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Role -> m Role Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Role -> m Role Source #

Binary Role Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods put_ :: WriteBinHandle -> Role -> IO () Source # put :: WriteBinHandle -> Role -> IO (Bin Role) Source # get :: ReadBinHandle -> IO Role Source #
Outputable Role Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods ppr :: Role -> SDoc Source #
Eq Role Source # |
Instance details Defined in Language.Haskell.Syntax.Basic Methods (==) :: Role -> Role -> Bool Source # (/=) :: Role -> Role -> Bool Source #
Ord Role Source # |
Instance details Defined in Language.Haskell.Syntax.Basic Methods compare :: Role -> Role -> Ordering Source # (<) :: Role -> Role -> Bool Source # (<=) :: Role -> Role -> Bool Source # (>) :: Role -> Role -> Bool Source # (>=) :: Role -> Role -> Bool Source # max :: Role -> Role -> Role Source # min :: Role -> Role -> Role Source #
type Anno (Maybe Role) Source # |
Instance details Defined in GHC.Hs.Decls type Anno (Maybe Role) = EpAnnCO

fsFromRole :: Role -> FastString Source #

data CoAxiomRule Source #

CoAxiomRule describes a built-in axiom, one that we assume to be true See Note [CoAxiomRule]

Constructors

BuiltInFamRew BuiltInFamRewrite |
BuiltInFamInj BuiltInFamInjectivity |
BranchedAxiom (CoAxiom Branched) BranchIndex |
UnbranchedAxiom (CoAxiom Unbranched) |

#### Instances

Instances details

Data CoAxiomRule Source # |

Instance details

Defined in GHC.Core.Coercion.Axiom

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> CoAxiomRule -> c CoAxiomRule Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c CoAxiomRule Source #

toConstr :: CoAxiomRule -> Constr Source #

dataTypeOf :: CoAxiomRule -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c CoAxiomRule) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c CoAxiomRule) Source #

gmapT :: (forall b. Data b => b -> b) -> CoAxiomRule -> CoAxiomRule Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> CoAxiomRule -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> CoAxiomRule -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> CoAxiomRule -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> CoAxiomRule -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> CoAxiomRule -> m CoAxiomRule Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> CoAxiomRule -> m CoAxiomRule Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> CoAxiomRule -> m CoAxiomRule Source #

Outputable CoAxiomRule Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods ppr :: CoAxiomRule -> SDoc Source #
Eq CoAxiomRule Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods (==) :: CoAxiomRule -> CoAxiomRule -> Bool Source # (/=) :: CoAxiomRule -> CoAxiomRule -> Bool Source #

data BuiltInFamRewrite Source #

Constructors

BIF_Rewrite |

Fields

- bifrw_name :: FastString
- bifrw_axr :: CoAxiomRule
- bifrw_fam_tc :: TyCon
- bifrw_arity :: Arity
- bifrw_match :: [Type] -> Maybe ([Type], Type)
- bifrw_proves :: [TypeEqn] -> Maybe TypeEqn

data BuiltInFamInjectivity Source #

Constructors

BIF_Interact |

Fields

- bifinj_name :: FastString
- bifinj_axr :: CoAxiomRule
- bifinj_proves :: TypeEqn -> Maybe TypeEqn

  Always unary: just one TypeEqn argument Returns `Nothing` when it doesn't like the supplied argument. When this happens in a coercion that means that the coercion is ill-formed, and Core Lint checks for that.

type TypeEqn = Pair Type Source #

A more explicit representation for `t1 ~ t2`.

coAxiomRuleArgRoles :: CoAxiomRule -> [Role] Source #

coAxiomRuleRole :: CoAxiomRule -> Role Source #

coAxiomRuleBranch_maybe :: CoAxiomRule -> Maybe (TyCon, Role, CoAxBranch) Source #

isNewtypeAxiomRule_maybe :: CoAxiomRule -> Maybe (TyCon, CoAxBranch) Source #

data BuiltInSynFamily Source #

Constructors

BuiltInSynFamily |

Fields

- sfMatchFam :: [BuiltInFamRewrite]
- sfInteract :: [BuiltInFamInjectivity]

trivialBuiltInFamily :: BuiltInSynFamily Source #

# Orphan instances

Binary Role Source # |
Instance details Methods put_ :: WriteBinHandle -> Role -> IO () Source # put :: WriteBinHandle -> Role -> IO (Bin Role) Source # get :: ReadBinHandle -> IO Role Source #
Outputable Role Source # |
Instance details Methods ppr :: Role -> SDoc Source #